<script lang="ts">
    import type { Repository } from "$lib/types/githubResults.type";
    import DownloadButton from "./DownloadButton.svelte";

    export let result: Repository;
    export let sources: { key: string; name: string }[];
    export let openDetailedView: () => void;
</script>

<tr>
    <td
        class="p-3 text-m font-bold text-blue-500 hover:text-blue-700 hover:cursor-pointer hover:underline"
    >
        <div class="flex flex-row justify-between items-center">
            <span
                on:click={openDetailedView}
                style="max-width: 300px; line-break: anywhere"
                on:keydown={(e) => {
                    if (e.key === "Enter") openDetailedView;
                }}
                role="button"
                tabindex="0"
            >
                {result.name}
            </span>

            <div class="flex items-center">
                <DownloadButton
                    data={[result]}
                    fileName={"BettysResult_" +
                        result.name.replace(/[\s+:]/g, "_")}
                />
            </div>
        </div>
    </td>
    {#each sources as source, i}
        <td
            class="p-3 whitespace-nowrap text-center text-m text-gray-700 {i ===
            0
                ? 'border-l-2'
                : i === sources.length - 1
                ? 'border-r-2'
                : ''}"
        >
            {result.amountPublications.get(source.key) ?? 0}
        </td>
    {/each}
    <td class="p-3 whitespace-nowrap text-m text-gray-700">
        {result.language}
    </td>
</tr>
